<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<?php
/*
 * Password Change PHP Script
 *
 * by Masayuki Nii (Facebook: Masayuki Nii, Twitter @masayukinii)
 *
 * This script required:
 *
 *  - Password can be changed by 'passwd' command.
 *  - 'expect' is exptected.
 *  - PHP5 is required.
 *
 * I've just tested as:
 *
 *  - OS X Lion v10.7.2
 *  - Apache 2.2.20/PHP 5.3.6
 *
 * Released: Dec 23, 2011
 */
$messages = '';
if ( count( $_POST ) > 0 ){
    $passed = '/usr/bin/passwd';
    $expect = '/usr/bin/expect';
    $prompt = 'password:';

    $q = '"';

    $user = addslashes($_POST['user']);
    $oldpass = addslashes($_POST['oldpass']);
    $newpass = addslashes($_POST['newpass']);
    $newpassretype = addslashes($_POST['newpassretype']);

    $messages = false;
    if ( strlen($user) < 1 )    {
        $messages .= '<div style="color:red">User Name should be specified.</div>';
    }
    if ( strlen($oldpass) < 1 )    {
        $messages .= '<div style="color:red">Old Password should be specified.</div>';
    }
    if ( strlen($newpass) < 1 )    {
        $messages .= '<div style="color:red">New Password should be specified.</div>';
    }
    if ( $newpass !== $newpassretype )    {
        $messages .= '<div style="color:red">New Password does NOT match the retyped. Password isn\'t changed.</div>';
    }

    if ( $messages === false )    {
        $expectCommand = "spawn {$passed} {$user};"
            . "expect {$q}{$prompt}{$q};send {$q}{$oldpass}\\r{$q};"
            . "expect {$q}{$prompt}{$q};send {$q}{$newpass}\\r{$q};"
            . "expect {$q}{$prompt}{$q};send {$q}{$newpass}\\r{$q};"
            . "expect eof";
        exec( "{$expect} -c '{$expectCommand}'", $output, $returnValue );
        $isFail = false;
        foreach( $output as $oneLine )  {
            if ( strpos($oneLine, 'failure') !== FALSE )    {
                $messages .="<div style={$q}color:red{$q}>Password for {$user} was NOT changed. Old Password won't be valid.</div>";
                $isFail = true;
            }
            if ( strpos($oneLine, 'unknown user') !== FALSE )    {
                $messages .="<div style={$q}color:red{$q}>User {$user} is unknown.</div>";
                $isFail = true;
            }
            //$messages .= "<div style={$q}color:green{$q}>{$oneLine}</div>";
        }
        //$messages .="<div>{$returnValue}</div>";
        //$messages .="<div>{$expectCommand}</div>";
        if ( ! $isFail )  {
            $messages .="<div style={$q}color:green{$q}>Password for {$user} will be changed successfully.</div>";
        }
    }
}
?>
<html>
<head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8"/>
    <title>Change Password</title>
</head>
<body>
<h1>Change Password</h1>
<p><?php echo $messages; ?></p>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
    <table>
        <tr>
            <th style="text-align:right">User Name:</th>
            <td>
                <input type="text" name="user" />
            </td>
        </tr>
        <tr>
            <th style="text-align:right">Old Password:</th>
            <td>
                <input type="password" name="oldpass" />
            </td>
        </tr>
        <tr>
            <th style="text-align:right">New Password:</th>
            <td>
                <input type="password" name="newpass" />
            </td>
        </tr>
        <tr>
            <th style="text-align:right">New Password (Retype):</th>
            <td>
                <input type="password" name="newpassretype" />
            </td>
        </tr>
        <tr>
            <th style="text-align:right"></th>
            <td>
                <button type="submit" name="button">Change Password</button>
            </td>
        </tr>
    </table>

</form>
</body>
</html>


